import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RlDatepickerPopupDirective } from './src/datepickerPopup.directive';
import { RlDatePickerInputComponent } from './src/datepicker-input.component';
import { RlDatePickerPopupComponent } from './src/datepicker-popup.component';
import { FormsModule } from '@angular/forms';
import { DatepickerModule } from 'ngx-bootstrap';
import 'rxjs/Rx';

export * from './src/datepicker-input.component';

@NgModule({
  imports: [
    CommonModule,
    FormsModule,
    DatepickerModule.forRoot()
  ],
  declarations: [
    RlDatePickerInputComponent,
    RlDatePickerPopupComponent,
    RlDatepickerPopupDirective,
  ],
  exports: [
    RlDatePickerInputComponent,
    RlDatePickerPopupComponent,
    RlDatepickerPopupDirective,
  ]
})
export class RlDatePickerModule {
  static forRoot(): ModuleWithProviders {
    return {
      ngModule: RlDatePickerModule
    };
  }
}
