import nodeResolve from 'rollup-plugin-node-resolve';
import { globalsRegex, GLOBAL } from 'rollup-globals-regex';

export default {
    entry: 'dist/index.js',
    dest: 'dist/bundles/rl-datepicker.umd.js',
    format: 'umd',
    moduleName: 'rlDatepicker',
    plugins: [
        {
            name: 'replace moment imports',
            transform: code =>
            ({
                code: code.replace(/import\s*\*\s*as\s*moment/g, 'import moment'),
                map: { mappings: '' }
            })
        },
        nodeResolve({ jsnext: true, browser: true })        
    ],
    globals: globalsRegex({
        'tslib': 'tslib',
        'moment' : 'moment',
        [GLOBAL.NG2]: GLOBAL.NG2.TPL,
        [GLOBAL.RX]: GLOBAL.RX.TPL,
        [GLOBAL.RX_OBSERVABLE]: GLOBAL.RX_OBSERVABLE.TPL,
        [GLOBAL.RX_OPERATOR]: GLOBAL.RX_OPERATOR.TPL,
    }),
    external: (moduleId) => {
        if (/^(\@angular|rxjs)\//.test(moduleId)) {
            return true;
        }

        return false;
    }
}