import { RlDatePickerInputComponent } from './datepicker-input.component';
import { Component, ElementRef, Input, ViewContainerRef, ViewChild, Output, EventEmitter, OnInit, OnDestroy, DoCheck } from '@angular/core';
import { AbstractControlDirective, NgControl } from '@angular/forms';
import { Observable } from 'rxjs/Observable';

@Component ({
  selector   : 'rl-datepicker-popup',
  templateUrl: './datepicker-popup.component.html'
})

export class RlDatePickerPopupComponent extends RlDatePickerInputComponent  {
    @Input() opened:boolean = false;
    @Input() OpenBtn:ElementRef;
    @Output() onClose:EventEmitter<any> = new EventEmitter();
    @Output() onDateChange: EventEmitter<Date> = new EventEmitter();
    
    constructor(el: ElementRef, control: NgControl){
        super(el, control);
    }

    ngOnInit ():void {
        super.ngOnInit();

        this.control.valueChanges.subscribe( value => {
           this.onDateChange.emit(value);
        });
    }

    ngDoCheck (): void {
        super.ngDoCheck();

        if(! this.opened && this.subscriber && ! this.subscriber.closed){
            setTimeout(()=>{
                this.removeEventListener();
                this.onClose.emit();
            },0)
        }else if(this.opened && (! this.subscriber || (this.subscriber && this.subscriber.closed) ) ){
            this.addEventListener();
        }
    }

    ngOnDestroy = () => {
        this.removeEventListener ();
        this.onClose.unsubscribe();
        this.onDateChange.unsubscribe();
    }

    protected get DatepickerElement (): HTMLElement {
        return <HTMLElement>(<Element>this.LayoutElement.children[ 0 ]);
    }
    
}
